Auto complete wiki page links

2020-08-06 04:03 - Mizuki ISHIKAWA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed   

Description

I think it would be useful to use the functionality of Tribute to auto complete the title of a wiki page at [[wiki page title]].
Related issues:

Related to Redmine - Feature #33425: Auto complete wiki macros New

Related to Redmine - Feature #31989: Inline issue auto complete (#) in fields... Closed

Associated revisions

Revision 20755 - 2021-02-25 05:07 - Go MAEDA

Auto complete wiki page links (#33820).

Patch by Mizuki ISHIKAWA.

Revision 20757 - 2021-02-27 09:15 - Go MAEDA

Fix RuboCop offense Style/BlockDelimiters due to r20755 (#33820).

Revision 20829 - 2021-03-19 05:42 - Go MAEDA

Sanitize HTML tags in wiki page names (#33820).

History

#1 - 2020-08-06 04:04 - Mizuki ISHIKAWA

- File feature-33820.patch added

I attach a patch that adds this feature.

#2 - 2020-08-12 10:06 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2020-10-12 00:18 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

Nice feature, let me find a better way to pass the auto complete endpoint for each case (issues, wiki pages, etc).

#4 - 2020-10-13 07:38 - Marius BĂLTEANU

- Related to Feature #33425: Auto complete wiki macros added

#5 - 2020-10-13 07:39 - Marius BĂLTEANU

- Related to Feature #31989: Inline issue auto complete (#) in fields with text-formatting enabled added

#6 - 2020-10-16 08:30 - Marius BĂLTEANU

Marius BALTEANU wrote:

Nice feature, let me find a better way to pass the auto complete endpoint for each case (issues, wiki pages, etc).
 I've posted an alternative solution in #34122, please let me know what do you think about it.

Beside this point, the patch needs at least two changes:

Use a collection for triggers (see my note from #33425)

Explore the possibility to show the wiki pages in parent - child relation or at least the parent if any in order to avoid confusion when there are

multiple pages with the same title, but under different parent pages.

#7 - 2020-10-16 08:30 - Marius BĂLTEANU

- Assignee deleted (Marius BĂLTEANU)

#8 - 2020-11-11 08:54 - Go MAEDA

Marius BALTEANU wrote:

Beside this point, the patch needs at least two changes:

Use a collection for triggers (see my note from #33425)

Explore the possibility to show the wiki pages in parent - child relation or at least the parent if any in order to avoid confusion when there are

multiple pages with the same title, but under different parent pages.

 I think the latter is not a problem. Wiki page names are unique in a project. You cannot create Wiki pages with the same name even if its parent

pages are different.

#9 - 2020-11-18 01:14 - Mizuki ISHIKAWA

- File feature-33820-v2.diff added

I fixed the patch by referring to the code of #34122.

#10 - 2021-02-08 15:02 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0 again.

#11 - 2021-02-10 23:46 - Marius BĂLTEANU

Mizuki, can you add a system tests for this? you should have enough examples.

#12 - 2021-02-15 01:29 - Mizuki ISHIKAWA

- File feature-33820-v3-with-test.patch added

Marius BALTEANU wrote:

Mizuki, can you add a system tests for this? you should have enough examples.

 I have attached a patch with system test added.

There are already tests to check that tributes work on other pages, so I'm only added testing that the issues/new page can autocomplete the wiki

page link.

#13 - 2021-02-17 15:20 - Go MAEDA

I found a security issue.

Auto complete for wiki pages should not suggest pages that the current user cannot view. The current patch always shows wiki pages even if the

current user does not have "View wiki".

#14 - 2021-02-25 01:42 - Mizuki ISHIKAWA

- File feature-33820-v4.patch added

Go MAEDA wrote:

I found a security issue.

Auto complete for wiki pages should not suggest pages that the current user cannot view. The current patch always shows wiki pages even if the

current user does not have "View wiki".
 Thank you for pointing that out.

I changed to return nothing when you do not have permission.

#15 - 2021-02-25 05:08 - Go MAEDA

- Subject changed from Auto Complete wiki page links to Auto complete wiki page links

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for improving Redmine.
